%define __spec_install_post %{nil}

Summary: Webmin module for 'LDAP Server'
Name: wbm-ldap-server
Version: 1.520
Release: 5.1
Requires: webmin perl-ldap wbm-ldap-client
BuildRequires: webmin wbm-ldap-client
License: GPL
Url:            http://xtec.cat/
Group: System/Tools
Source: ldap-server.tar.gz
Vendor:         linkat
Distribution:   education
BuildRoot: /tmp/%{name}-%{version}
BuildArchitectures: noarch



%description
Webmin module for 'LDAP Server' in RPM format

%prep
%setup -n ldap-server

%build
(find . -name '*.cgi' ; find . -name '*.pl') | perl -ne 'chop; open(F,$_); @l=<F>; close(F); $l[0] = "#!/usr/bin/perl$1
" if ($l[0] =~ /#!\S*perl\S*(.*)/); open(F,">$_"); print F @l; close(F)'
(find . -name '*.cgi' ; find . -name '*.pl') | xargs chmod +x

%install
mkdir -p %{buildroot}/usr/share/webmin/ldap-server
cp -rp * %{buildroot}/usr/share/webmin/ldap-server
echo rpm >%{buildroot}/usr/share/webmin/ldap-server/install-type

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
/usr/share/webmin/ldap-server

%pre
# Check if webmin/usermin is installed
if [ ! -r /etc/webmin/config -o ! -d /usr/share/webmin ]; then
	echo "Webmin does not appear to be installed on your system."
	echo "This RPM cannot be installed unless the RPM version of Webmin"
	echo "is installed first."
	exit 1
fi
if [ "ldap-client" != "" -a "" != 1 ]; then
	# Check if depended webmin/usermin modules are installed
	for d in ldap-client; do
		if [ ! -r /usr/share/webmin/$d/module.info ]; then
			echo "This Webmin module depends on the module $d, which is"
			echo "not installed on your system."
			exit 1
		fi
	done
fi
# Check if this module is already installed
if [ -d /usr/share/webmin/ldap-server -a "$1" = "1" -a "0" != "1" ]; then
	echo "This Webmin module is already installed on your system."
	exit 1
fi

%post
if [ "1" = "1" ]; then
	# Copy config file to /etc/webmin or /etc/usermin
	os_type=`grep "^os_type=" /etc/webmin/config | sed -e 's/os_type=//g'`
	os_version=`grep "^os_version=" /etc/webmin/config | sed -e 's/os_version=//g'`
	/usr/bin/perl /usr/share/webmin/copyconfig.pl suse 11.2 /usr/share/webmin /etc/webmin ldap-server

	# Update the ACL for the root user, or the first user in the ACL
	grep "^root:" /etc/webmin/webmin.acl >/dev/null
	if [ "$?" = "0" ]; then
		user=root
	else
		user=`head -1 /etc/webmin/webmin.acl | cut -f 1 -d :`
	fi
	mods=`grep $user: /etc/webmin/webmin.acl | cut -f 2 -d :`
	echo $mods | grep " ldap-server" >/dev/null
	if [ "$?" != "0" ]; then
		grep -v ^$user: /etc/webmin/webmin.acl > /tmp/webmin.acl.tmp
		echo $user: $mods ldap-server > /etc/webmin/webmin.acl
		cat /tmp/webmin.acl.tmp >> /etc/webmin/webmin.acl
		rm -f /tmp/webmin.acl.tmp
	fi
fi
if [ "" != "" -a "" = "1" ]; then
	# Activate this theme
	grep -v "^preroot=" /etc/webmin/miniserv.conf >/etc/webmin/miniserv.conf.tmp
	(cat /etc/webmin/miniserv.conf.tmp ; echo preroot=ldap-server) > /etc/webmin/miniserv.conf
	rm -f /etc/webmin/miniserv.conf.tmp
	grep -v "^theme=" /etc/webmin/config >/etc/webmin/config.tmp
	(cat /etc/webmin/config.tmp ; echo theme=ldap-server) > /etc/webmin/config
	rm -f /etc/webmin/config.tmp
	(/etc/webmin/stop && /etc/webmin/start) >/dev/null 2>&1
fi
rm -f /etc/webmin/module.infos.cache

# Run post-install function
if [ "webmin" = "webmin" ]; then
	cd /usr/share/webmin
	WEBMIN_CONFIG=/etc/webmin WEBMIN_VAR=/var/webmin /usr/share/webmin/run-postinstalls.pl ldap-server
fi

# Run post-install shell script
if [ -r "/usr/share/webmin/ldap-server/postinstall.sh" ]; then
	cd /usr/share/webmin
	WEBMIN_CONFIG=/etc/webmin WEBMIN_VAR=/var/webmin /usr/share/webmin/ldap-server/postinstall.sh
fi

%preun
# De-activate this theme, if in use and if we are not upgrading
if [ "" = "1" -a "$1" = "0" ]; then
	grep "^preroot=ldap-server" /etc/webmin/miniserv.conf >/dev/null
	if [ "$?" = "0" ]; then
		grep -v "^preroot=ldap-server" /etc/webmin/miniserv.conf >/etc/webmin/miniserv.conf.tmp
		(cat /etc/webmin/miniserv.conf.tmp) > /etc/webmin/miniserv.conf
		rm -f /etc/webmin/miniserv.conf.tmp
		grep -v "^theme=ldap-server" /etc/webmin/config >/etc/webmin/config.tmp
		(cat /etc/webmin/config.tmp) > /etc/webmin/config
		rm -f /etc/webmin/config.tmp
		(/etc/webmin/stop && /etc/webmin/start) >/dev/null 2>&1
	fi
fi
# Run the pre-uninstall script, if we are not upgrading
if [ "webmin" = "webmin" -a "$1" = "0" -a -r "/usr/share/webmin/ldap-server/uninstall.pl" ]; then
	cd /usr/share/webmin
	WEBMIN_CONFIG=/etc/webmin WEBMIN_VAR=/var/webmin /usr/share/webmin/run-uninstalls.pl ldap-server
fi
/bin/true

%postun

%changelog

* Tue Nov 09 2010 - Jordi "Txor" Casas Ríos - <jordi.casas@opentrends.net>
- Added perl-ldap requires.

* Tue Nov 09 2010 - Jordi "Txor" Casas Ríos - <jordi.casas@opentrends.net>
- Changed slapd path on config items file to match openldap2 paths.

* Tue Nov 08 2010 - Jordi "Txor" Casas Ríos - <jordi.casas@opentrends.net>
- Initial release.

